Index: /branches/OMEdit/OMEditGUI/Component.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/Component.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/Component.cpp	(revision 13537)
@@ -2133,4 +1079,5 @@
   mCasuality = "";
   mArrayIndex = "";
+  mIsArray = false;
   parseString(value);
 }
@@ -2217,4 +1164,6 @@
   // read the array index value
   mArrayIndex = StringHandler::removeFirstLastCurlBrackets(list.at(11));
+  if ((mArrayIndex.compare("n") == 0) || (mArrayIndex.compare(":") == 0))
+    mIsArray = true;
 }
 
@@ -2283,2 +1232,7 @@
   return mArrayIndex;
 }
+
+bool ComponentInfo::isArray()
+{
+  return mIsArray;
+}
Index: /branches/OMEdit/OMEditGUI/Component.h
===================================================================
--- /branches/OMEdit/OMEditGUI/Component.h	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/Component.h	(revision 13537)
@@ -68,16 +68,16 @@
 class IconParameters;
 
-class Component_OMC : public QObject, public QGraphicsItem
+class Component : public QObject, public QGraphicsItem
 {
   Q_OBJECT
   Q_INTERFACES(QGraphicsItem)
 public:
-  Component_OMC(QString annotation, QString name, QString className, StringHandler::ModelicaClasses type, QString transformation,
-                QPointF position, OMCProxy *pOMCProxy, GraphicsView *pGraphicsView, Component_OMC *pParent = 0);
-  Component_OMC(QString annotation, QString className, StringHandler::ModelicaClasses type, Component_OMC *pParent);
-  Component_OMC(QString annotation, QString transformationString, ComponentInfo *pComponentInfo, StringHandler::ModelicaClasses type,
-                Component_OMC *pParent);
+  Component(QString annotation, QString name, QString className, StringHandler::ModelicaClasses type, QString transformation,
+                QPointF position, OMCProxy *pOMCProxy, GraphicsView *pGraphicsView, Component *pParent = 0);
+  Component(QString annotation, QString className, StringHandler::ModelicaClasses type, Component *pParent);
+  Component(QString annotation, QString transformationString, ComponentInfo *pComponentInfo, StringHandler::ModelicaClasses type,
+                Component *pParent);
   /* Used for Library Component */
-  Component_OMC(QString annotation, QString className, OMCProxy *pOMCProxy, Component_OMC *pParent = 0);
+  Component(QString annotation, QString className, OMCProxy *pOMCProxy, Component *pParent = 0);
   void initialize();
   bool isLibraryComponent();
@@ -97,11 +97,11 @@
   OMCProxy* getOMCProxy();
   GraphicsView* getGraphicsView();
-  Component_OMC* getParentComponent();
-  Component_OMC* getRootParentComponent();
+  Component* getParentComponent();
+  Component* getRootParentComponent();
   Transformation* getTransformation();
   ComponentInfo* getComponentInfo();
-  QList<Component_OMC*> getInheritanceList();
-  QList<ShapeAnnotation_OMC*> getShapesList();
-  QList<Component_OMC*> getComponentsList();
+  QList<Component*> getInheritanceList();
+  QList<ShapeAnnotation*> getShapesList();
+  QList<Component*> getComponentsList();
   void setOldPosition(QPointF oldPosition);
   QPointF getOldPosition();
@@ -115,5 +115,5 @@
   void applyRotation(qreal angle);
   void applyFlip(StringHandler::Flip flip);
-  void addConnectionDetails(LineAnnotation_OMC *pConnectorLineAnnotation);
+  void addConnectionDetails(LineAnnotation *pConnectorLineAnnotation);
   void updateConnection();
 private:
@@ -123,5 +123,5 @@
   OMCProxy *mpOMCProxy;
   GraphicsView *mpGraphicsView;
-  Component_OMC *mpParentComponent;
+  Component *mpParentComponent;
   bool mIsLibraryComponent;
   bool mVisible;
@@ -143,11 +143,11 @@
   qreal mYFactor;
   ComponentInfo *mpComponentInfo;
-  QList<Component_OMC*> mpInheritanceList;
-  QList<ShapeAnnotation_OMC*> mpShapesList;
-  QList<Component_OMC*> mpComponentsList;
+  QList<Component*> mpInheritanceList;
+  QList<ShapeAnnotation*> mpShapesList;
+  QList<Component*> mpComponentsList;
   QPointF mOldPosition;
   bool mIsMousePressed;
 signals:
-  void componentClicked(Component_OMC*);
+  void componentClicked(Component*);
   void componentTransformChange();
   void componentTransformHasChanged();
@@ -174,108 +174,4 @@
 };
 
-class Component : public ShapeAnnotation
-{
-  Q_OBJECT
-private:
-  QString mAnnotationString;
-  bool mIsConnector;
-  QString mName;
-  QString mClassName;
-  QList<CornerItem1*> mCornerItemsList;
-  CornerItem *mpTopLeftCornerItem;
-  CornerItem *mpTopRightCornerItem;
-  CornerItem *mpBottomLeftCornerItem;
-  CornerItem *mpBottomRightCornerItem;
-  QAction *mpIconPropertiesAction;
-  QAction *mpIconAttributesAction;
-  QAction *mpIsConnectModeAction;
-  QRectF mRectangle;    // stores the extent points
-  QString mTransformationString;
-  bool mPreserveAspectRatio;
-  qreal mInitialScale;
-  QList<qreal> mGrid;
-  Component *mpParentComponent;
-  OMCProxy *mpOMCProxy;
-  GraphicsView *mpGraphicsView;
-  ComponentInfo *mpComponentProperties;
-  QList<ComponentInfo*> mpChildComponentInfo;
-  QList<ShapeAnnotation*> mpShapesList;
-  QList<Component*> mpInheritanceList;
-  QList<Component*> mpComponentsList;
-  //QList<IconParameters*> mIconParametersList;
-  bool mIsLibraryComponent;
-  QPointF mOldPosition;
-  bool mIsMousePressed;
-
-  void createActions();
-public:
-  Component(QString value, QString name, QString className, QString transformationString, QPointF position, bool connector, OMCProxy *omc,
-            GraphicsView *graphicsView, Component *pParent = 0);
-  Component(QString value, QString className, bool connector, Component *pParent = 0);
-  Component(QString value, QString transformationString, ComponentInfo *pComponentInfo, bool connector, Component *pParent = 0);
-  /* Used for Library Component */
-  Component(QString value, QString className, bool connector, OMCProxy *omc, Component *pParent = 0);
-  /* Copy Constructors */
-  Component(Component *pComponent, QString name, QString transformationString, QPointF position, bool connector, GraphicsView *graphicsView,
-            Component *pParent = 0);
-  /* Copy Constructors */
-  ~Component();
-  void initialize();
-  bool parseAnnotationString(QString value);
-  QRectF boundingRect() const;
-  void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget = 0);
-  QString getName();
-  void updateName(QString newName);
-  void updateParameterValue(QString oldValue, QString newValue);
-  QString getClassName();
-  OMCProxy* getOMCProxy();
-  GraphicsView* getGraphicsView();
-  Component* getParentComponent();
-  Component* getRootParentComponent(bool secondLast = false);
-  QList<Component*> getInheritanceList();
-  QList<ShapeAnnotation*> getShapesList();
-  QList<Component*> getComponentsList();
-  ComponentInfo *getComponentInfo();
-  QList<ComponentInfo*> getChildComponentInfo();
-  QRectF getRectangle();
-  QString getTransformationString();
-  bool isLibraryComponent();
-  void setOldPosition(QPointF oldPosition);
-  QPointF getOldPosition();
-  void setMousePressed(bool On);
-  void getClassInheritedComponents();
-  void getClassComponents();
-  //void getClassComponents(QString className, int type, Component *pParent);
-  void copyClassInheritedComponents(Component *pComponent);
-  void copyClassComponents(Component *pComponent);
-  void addConnector(Connector *item);
-  void setComponentFlags();
-  void unsetComponentFlags();
-  bool getIsConnector();
-  QString getTransformationAnnotationString();
-signals:
-  void componentClicked(Component*);
-  void connectorComponentClicked(Component*);
-  void componentMoved();
-  void componentPositionChanged();
-  void componentDeleted();
-  void componentSelected();
-  void componentRotated(bool isRotated);
-  void componentScaled();
-public slots:
-  void updateAnnotationString(bool updateBothViews = true);
-  void deleteMe(bool update = true);
-  void copyComponent();
-  void openIconProperties();
-  void openIconAttributes();
-protected:
-  virtual void mousePressEvent(QGraphicsSceneMouseEvent *event);
-  virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent *event);
-  virtual void hoverEnterEvent(QGraphicsSceneHoverEvent *event);
-  virtual void hoverLeaveEvent(QGraphicsSceneHoverEvent *event);
-  virtual void contextMenuEvent(QGraphicsSceneContextMenuEvent *event);
-  virtual QVariant itemChange(GraphicsItemChange change, const QVariant &value);
-};
-
 class ComponentInfo
 {
@@ -296,4 +192,5 @@
   QString getCasuality();
   QString getArrayIndex();
+  bool isArray();
 private:
   QString mClassName;
@@ -312,4 +209,5 @@
   QString mCasuality;
   QString mArrayIndex;
+  bool mIsArray;
 };
 
Index: /branches/OMEdit/OMEditGUI/CornerItem.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/CornerItem.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/CornerItem.cpp	(revision 13537)
@@ -35,107 +35,4 @@
 
 #include "CornerItem.h"
-
-RectangleCornerItem::RectangleCornerItem(qreal x, qreal y, int connectedPointIndex, ShapeAnnotation *pParent)
-  : QGraphicsItem(pParent), mItemClicked(false), mConnectedPointIndex(connectedPointIndex)
-{
-  setFlags(QGraphicsItem::ItemIgnoresTransformations | QGraphicsItem::ItemIsMovable | QGraphicsItem::ItemIsSelectable
-           | QGraphicsItem::ItemSendsGeometryChanges);
-  setAcceptHoverEvents(true);
-  scale(1.0, -1.0);
-  mActivePen = QPen(Qt::red);
-  mHoverPen = QPen(Qt::darkRed);
-  setPos(x, y);
-  mRectangle = QRectF (-3, -3, 6, 6);
-  setActive();
-
-  mpShapeAnnotation = pParent;
-  connect(this, SIGNAL(itemMoved(int,QPointF)), mpShapeAnnotation, SLOT(updatePoint(int,QPointF)));
-  connect(this, SIGNAL(itemClicked()), mpShapeAnnotation, SLOT(doSelect()));
-  connect(this, SIGNAL(itemUnClicked()), mpShapeAnnotation, SLOT(doUnSelect()));
-  connect(this, SIGNAL(itemPositionUpdate()), mpShapeAnnotation->mpGraphicsView, SLOT(addClassAnnotation()));
-}
-
-//! Tells the box to become visible and use active style.
-//! @see setPassive();
-//! @see setHovered();
-void RectangleCornerItem::setActive()
-{
-  setVisible(true);
-  mPen = mActivePen;
-  update();
-}
-
-//! Tells the box to become invisible.
-//! @see setActive();
-//! @see setHovered();
-void RectangleCornerItem::setPassive()
-{
-  setVisible(false);
-}
-
-//! Tells the box to become visible and use hovered style.
-//! @see setActive();
-//! @see setPassive();
-void RectangleCornerItem::setHovered()
-{
-  setVisible(true);
-  mPen = mHoverPen;
-}
-
-QRectF RectangleCornerItem::boundingRect() const
-{
-  return mRectangle;
-}
-
-void RectangleCornerItem::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
-{
-  Q_UNUSED(option);
-  Q_UNUSED(widget);
-  painter->setPen(mPen);
-  painter->setBrush(mPen.color());
-  painter->drawRect(mRectangle);
-}
-
-//! Event when mouse cursor enters component icon.
-void RectangleCornerItem::hoverEnterEvent(QGraphicsSceneHoverEvent *event)
-{
-  Q_UNUSED(event);
-  setCursor(Qt::ArrowCursor);
-}
-
-//! Event when mouse cursor leaves component icon.
-void RectangleCornerItem::hoverLeaveEvent(QGraphicsSceneHoverEvent *event)
-{
-  Q_UNUSED(event);
-  unsetCursor();
-}
-
-void RectangleCornerItem::mousePressEvent(QGraphicsSceneMouseEvent *event)
-{
-  emit itemClicked();
-  mClickPos = mapToScene(event->pos());
-  QGraphicsItem::mousePressEvent(event);
-}
-
-void RectangleCornerItem::mouseReleaseEvent(QGraphicsSceneMouseEvent *event)
-{
-  emit itemUnClicked();
-  if (mClickPos != mapToScene(event->pos()))
-  {
-    emit itemPositionUpdate();
-  }
-  mpShapeAnnotation->setSelected(true);
-  QGraphicsItem::mouseReleaseEvent(event);
-}
-
-QVariant RectangleCornerItem::itemChange(GraphicsItemChange change, const QVariant &value)
-{
-  QGraphicsItem::itemChange(change, value);
-  if (change == QGraphicsItem::ItemPositionHasChanged)
-  {
-    emit itemMoved(mConnectedPointIndex, value.toPointF());
-  }
-  return value;
-}
 
 ResizerItem::ResizerItem(int index, QGraphicsItem *pParent)
Index: /branches/OMEdit/OMEditGUI/CornerItem.h
===================================================================
--- /branches/OMEdit/OMEditGUI/CornerItem.h	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/CornerItem.h	(revision 13537)
@@ -44,43 +44,7 @@
 #include "Component.h"
 
-class ShapeAnnotation;
 class Component;
-class Component_OMC;
 class GraphicsScene;
 class GraphicsView;
-
-class RectangleCornerItem : public QObject, public QGraphicsItem
-{
-  Q_OBJECT
-  Q_INTERFACES(QGraphicsItem)
-private:
-  QRectF mRectangle;
-  QPen mPen;
-  QPen mActivePen;
-  QPen mHoverPen;
-  bool mItemClicked;
-  QPointF mClickPos;
-  int mConnectedPointIndex;
-public:
-  RectangleCornerItem(qreal x, qreal y, int connectedPointIndex, ShapeAnnotation *pParent = 0);
-  void setActive();
-  void setPassive();
-  void setHovered();
-  QRectF boundingRect() const;
-  void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget = 0);
-
-  ShapeAnnotation *mpShapeAnnotation;
-signals:
-  void itemMoved(int index, QPointF point);
-  void itemClicked();
-  void itemUnClicked();
-  void itemPositionUpdate();
-protected:
-  virtual void hoverEnterEvent(QGraphicsSceneHoverEvent *event);
-  virtual void hoverLeaveEvent(QGraphicsSceneHoverEvent *event);
-  virtual void mousePressEvent(QGraphicsSceneMouseEvent *event);
-  virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent *event);
-  QVariant itemChange(GraphicsItemChange change, const QVariant &value);
-};
 
 //This class is the black or red boxes that appears around a selected item or items so the user can scale or rotate
Index: /branches/OMEdit/OMEditGUI/EllipseAnnotation.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/EllipseAnnotation.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/EllipseAnnotation.cpp	(revision 13537)
@@ -37,11 +37,11 @@
 
 
-EllipseAnnotation_OMC::EllipseAnnotation_OMC(QString annotation, Component_OMC *pParent)
-  : ShapeAnnotation_OMC(pParent)
+EllipseAnnotation::EllipseAnnotation(QString annotation, Component *pParent)
+  : ShapeAnnotation(pParent)
 {
   parseShapeAnnotation(annotation);
 }
 
-void EllipseAnnotation_OMC::parseShapeAnnotation(QString annotation)
+void EllipseAnnotation::parseShapeAnnotation(QString annotation)
 {
   GraphicItem::parseShapeAnnotation(annotation);
@@ -65,63 +65,4 @@
 }
 
-QRectF EllipseAnnotation_OMC::boundingRect() const
-{
-  return shape().boundingRect();
-}
-
-QPainterPath EllipseAnnotation_OMC::shape() const
-{
-  QPainterPath path;
-  path.addEllipse(getBoundingRect());
-  return addPathStroker(path);
-}
-
-void EllipseAnnotation_OMC::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
-{
-  Q_UNUSED(option);
-  Q_UNUSED(widget);
-  if (transformOriginPoint() != boundingRect().center())
-    setTransformOriginPoint(boundingRect().center());
-  drawEllipseAnnotaion(painter);
-}
-
-void EllipseAnnotation_OMC::drawEllipseAnnotaion(QPainter *painter)
-{
-  applyLinePattern(painter);
-  applyFillPattern(painter);
-  QPainterPath path;
-  path.addEllipse(boundingRect());
-  painter->drawPath(path);
-}
-
-
-EllipseAnnotation::EllipseAnnotation(QString shape, Component *pParent)
-  : ShapeAnnotation(pParent), mpComponent(pParent)
-{
-  initializeFields();
-  parseShapeAnnotation(shape, mpComponent->getOMCProxy());
-}
-
-EllipseAnnotation::EllipseAnnotation(GraphicsView *graphicsView, QGraphicsItem *pParent)
-  : ShapeAnnotation(graphicsView, pParent)
-{
-  // initialize all fields with default values
-  initializeFields();
-  mIsCustomShape = true;
-  setAcceptHoverEvents(true);
-  connect(this, SIGNAL(updateShapeAnnotation()), mpGraphicsView, SLOT(addClassAnnotation()));
-}
-
-EllipseAnnotation::EllipseAnnotation(QString shape, GraphicsView *graphicsView, QGraphicsItem *pParent)
-  : ShapeAnnotation(graphicsView, pParent)
-{
-  // initialize all fields with default values
-  initializeFields();
-  parseShapeAnnotation(shape, mpGraphicsView->getModelWidget()->getModelWidgetContainer()->getMainWindow()->getOMCProxy());
-  mIsCustomShape = true;
-  setAcceptHoverEvents(true);
-  connect(this, SIGNAL(updateShapeAnnotation()), mpGraphicsView, SLOT(addClassAnnotation()));
-}
-
 QRectF EllipseAnnotation::boundingRect() const
 {
@@ -140,9 +81,6 @@
   Q_UNUSED(option);
   Q_UNUSED(widget);
-
   if (transformOriginPoint() != boundingRect().center())
-  {
     setTransformOriginPoint(boundingRect().center());
-  }
   drawEllipseAnnotaion(painter);
 }
@@ -150,219 +88,8 @@
 void EllipseAnnotation::drawEllipseAnnotaion(QPainter *painter)
 {
+  applyLinePattern(painter);
+  applyFillPattern(painter);
   QPainterPath path;
-
-  switch (this->mFillPattern)
-  {
-    case Qt::LinearGradientPattern:
-    {
-      QLinearGradient gradient(boundingRect().center().x(), boundingRect().center().y(), boundingRect().center().x(), boundingRect().y());
-      gradient.setColorAt(0.0, this->mFillColor);
-      gradient.setColorAt(1.0, this->mLineColor);
-      gradient.setSpread(QGradient::ReflectSpread);
-      painter->setBrush(gradient);
-      break;
-    }
-    case Qt::Dense1Pattern:
-    {
-      QLinearGradient gradient(boundingRect().center().x(), boundingRect().center().y(),
-                               boundingRect().x(), boundingRect().center().y());
-      gradient.setColorAt(0.0, this->mFillColor);
-      gradient.setColorAt(1.0, this->mLineColor);
-      gradient.setSpread(QGradient::ReflectSpread);
-      painter->setBrush(gradient);
-      break;
-    }
-    case Qt::RadialGradientPattern:
-    {
-      QRadialGradient gradient(boundingRect().center().x(), boundingRect().center().y(), boundingRect().width());
-      gradient.setColorAt(0.0, this->mFillColor);
-      gradient.setColorAt(1.0, this->mLineColor);
-      gradient.setSpread(QGradient::ReflectSpread);
-      painter->setBrush(gradient);
-      break;
-    }
-    default:
-      painter->setBrush(QBrush(this->mFillColor, this->mFillPattern));
-      break;
-  }
-  // make the pen width upper rounded, otherwise ellipse is distorted
-  qreal thickness = ceil(mThickness);
-
-  QPen pen(mLineColor, thickness, this->mLinePattern);
-  pen.setCosmetic(true);
-  painter->setPen(pen);
-
   path.addEllipse(boundingRect());
   painter->drawPath(path);
 }
-
-void EllipseAnnotation::addPoint(QPointF point)
-{
-  mExtent.append(point);
-}
-
-void EllipseAnnotation::updateEndPoint(QPointF point)
-{
-  mExtent.back() = point;
-}
-
-void EllipseAnnotation::drawRectangleCornerItems()
-{
-  mIsFinishedCreatingShape = true;
-  for (int i = 0 ; i < this->mExtent.size() ; i++)
-  {
-    QPointF point = this->mExtent.at(i);
-    RectangleCornerItem *rectangleCornerItem = new RectangleCornerItem(point.x(), point.y(), i, this);
-    mRectangleCornerItemsList.append(rectangleCornerItem);
-  }
-  emit updateShapeAnnotation();
-}
-
-QString EllipseAnnotation::getShapeAnnotation()
-{
-  QString annotationString;
-  annotationString.append("Ellipse(");
-
-  if (!mVisible)
-  {
-    annotationString.append("visible=false,");
-  }
-
-  annotationString.append("rotation=").append(QString::number(this->rotation())).append(",");
-
-  annotationString.append("lineColor={");
-  annotationString.append(QString::number(mLineColor.red())).append(",");
-  annotationString.append(QString::number(mLineColor.green())).append(",");
-  annotationString.append(QString::number(mLineColor.blue()));
-  annotationString.append("},");
-
-  annotationString.append("fillColor={");
-  annotationString.append(QString::number(mFillColor.red())).append(",");
-  annotationString.append(QString::number(mFillColor.green())).append(",");
-  annotationString.append(QString::number(mFillColor.blue()));
-  annotationString.append("},");
-
-  QMap<QString, Qt::PenStyle>::iterator it;
-  for (it = this->mLinePatternsMap.begin(); it != this->mLinePatternsMap.end(); ++it)
-  {
-    if (it.value() == mLinePattern)
-    {
-      annotationString.append("pattern=LinePattern.").append(it.key()).append(",");
-      break;
-    }
-  }
-
-  QMap<QString, Qt::BrushStyle>::iterator fill_it;
-  for (fill_it = this->mFillPatternsMap.begin(); fill_it != this->mFillPatternsMap.end(); ++fill_it)
-  {
-    if (fill_it.value() == mFillPattern)
-    {
-      annotationString.append("fillPattern=FillPattern.").append(fill_it.key()).append(",");
-      break;
-    }
-  }
-
-  annotationString.append("lineThickness=").append(QString::number(mThickness)).append(",");
-  annotationString.append("extent={{");
-  annotationString.append(QString::number(mapToScene(mExtent.at(0)).x())).append(",");
-  annotationString.append(QString::number(mapToScene(mExtent.at(0)).y())).append("},{");
-  annotationString.append(QString::number(mapToScene(mExtent.at(1)).x())).append(",");
-  annotationString.append(QString::number(mapToScene(mExtent.at(1)).y()));
-  annotationString.append("}}");
-
-  annotationString.append(")");
-  return annotationString;
-}
-
-void EllipseAnnotation::updatePoint(int index, QPointF point)
-{
-  mExtent.replace(index, point);
-}
-
-void EllipseAnnotation::parseShapeAnnotation(QString shape, OMCProxy *omc)
-{
-  // Remove { } from shape
-
-  shape = shape.replace("{", "");
-  shape = shape.replace("}", "");
-
-  // parse the shape to get the list of attributes of Ellipse.
-  QStringList list = StringHandler::getStrings(shape);
-  if (list.size() < 14)
-  {
-    return;
-  }
-
-  // if first item of list is true then the Ellipse should be visible.
-  this->mVisible = static_cast<QString>(list.at(0)).contains("true");
-
-  int index = 0;
-  mOrigin.setX(static_cast<QString>(list.at(1)).toFloat());
-  mOrigin.setY(static_cast<QString>(list.at(2)).toFloat());
-  mRotation = static_cast<QString>(list.at(3)).toFloat();
-  index = 3;
-  // 2,3,4 items of list contains the line color.
-  index = index + 1;
-  int red, green, blue;
-
-  red = static_cast<QString>(list.at(index)).toInt();
-  index = index + 1;
-  green = static_cast<QString>(list.at(index)).toInt();
-  index = index + 1;
-  blue = static_cast<QString>(list.at(index)).toInt();
-  this->mLineColor = QColor (red, green, blue);
-
-  // 5,6,7 items of list contains the fill color.
-  index = index + 1;
-  red = static_cast<QString>(list.at(index)).toInt();
-  index = index + 1;
-  green = static_cast<QString>(list.at(index)).toInt();
-  index = index + 1;
-  blue = static_cast<QString>(list.at(index)).toInt();
-  this->mFillColor = QColor (red, green, blue);
-
-  // 8 item of the list contains the line pattern.
-  index = index + 1;
-  QString linePattern = StringHandler::getLastWordAfterDot(list.at(index));
-  QMap<QString, Qt::PenStyle>::iterator it;
-  for (it = this->mLinePatternsMap.begin(); it != this->mLinePatternsMap.end(); ++it)
-  {
-    if (it.key().compare(linePattern) == 0)
-    {
-      this->mLinePattern = it.value();
-      break;
-    }
-  }
-
-  // 9 item of the list contains the fill pattern.
-  index = index + 1;
-  QString fillPattern = StringHandler::getLastWordAfterDot(list.at(index));
-  QMap<QString, Qt::BrushStyle>::iterator fill_it;
-  for (fill_it = this->mFillPatternsMap.begin(); fill_it != this->mFillPatternsMap.end(); ++fill_it)
-  {
-    if (fill_it.key().compare(fillPattern) == 0)
-    {
-      this->mFillPattern = fill_it.value();
-      break;
-    }
-  }
-
-  // 10 item of the list contains the thickness.
-  index = index + 1;
-  this->mThickness = static_cast<QString>(list.at(index)).toFloat();
-
-  // 11, 12, 13, 14 items of the list contains the extent points of Ellipse.
-  index = index + 1;
-  qreal x = static_cast<QString>(list.at(index)).toFloat();
-  index = index + 1;
-  qreal y = static_cast<QString>(list.at(index)).toFloat();
-  QPointF p1 (x, y);
-  index = index + 1;
-  x = static_cast<QString>(list.at(index)).toFloat();
-  index = index + 1;
-  y = static_cast<QString>(list.at(index)).toFloat();
-  QPointF p2 (x, y);
-
-  this->mExtent.append(p1);
-  this->mExtent.append(p2);
-}
Index: /branches/OMEdit/OMEditGUI/EllipseAnnotation.h
===================================================================
--- /branches/OMEdit/OMEditGUI/EllipseAnnotation.h	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/EllipseAnnotation.h	(revision 13537)
@@ -41,11 +41,11 @@
 
 class OMCProxy;
-class Component_OMC;
+class Component;
 
-class EllipseAnnotation_OMC : public ShapeAnnotation_OMC
+class EllipseAnnotation : public ShapeAnnotation
 {
   Q_OBJECT
 public:
-  EllipseAnnotation_OMC(QString annotation, Component_OMC *pParent);
+  EllipseAnnotation(QString annotation, Component *pParent);
   void parseShapeAnnotation(QString annotation);
   QRectF boundingRect() const;
@@ -58,26 +58,3 @@
 };
 
-
-class EllipseAnnotation : public ShapeAnnotation
-{
-  Q_OBJECT
-public:
-  EllipseAnnotation(QString shape, Component *pParent);
-  EllipseAnnotation(GraphicsView *graphicsView, QGraphicsItem *pParent = 0);
-  EllipseAnnotation(QString shape, GraphicsView *graphicsView, QGraphicsItem *pParent = 0);
-  QRectF boundingRect() const;
-  QPainterPath shape() const;
-  void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget = 0);
-  void drawEllipseAnnotaion(QPainter *painter);
-  void addPoint(QPointF point);
-  void updateEndPoint(QPointF point);
-  void drawRectangleCornerItems();
-  QString getShapeAnnotation();
-  void parseShapeAnnotation(QString shape, OMCProxy *omc);
-
-  Component *mpComponent;
-public slots:
-  void updatePoint(int index, QPointF point);
-};
-
 #endif // ELLIPSEANNOTATION_H
Index: /branches/OMEdit/OMEditGUI/Helper.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/Helper.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/Helper.cpp	(revision 13537)
@@ -165,4 +165,5 @@
 QString Helper::center;
 QString Helper::right;
+QString Helper::connectArray;
 
 void Helper::initHelperVariables()
@@ -252,4 +253,5 @@
   Helper::center = tr("Center");
   Helper::right = tr("Right");
+  Helper::connectArray = tr("Connect Array");
 }
 
@@ -319,5 +321,5 @@
       return tr("The file <b>%1</b> is not a valid Modelica file. The file format is not supported. You can only open <b>%2</b>.");
     case ENTER_VALID_INTEGER:
-      return tr("Enter a valid Positive Integer");
+      return tr("Enter a valid positive integer index value for <b>%1</b>.");
     case ITEM_DROPPED_ON_ITSELF:
       return tr("You cannot drop an item on itself.");
Index: /branches/OMEdit/OMEditGUI/Helper.h
===================================================================
--- /branches/OMEdit/OMEditGUI/Helper.h	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/Helper.h	(revision 13537)
@@ -185,4 +185,5 @@
   static QString center;
   static QString right;
+  static QString connectArray;
 };
 
Index: /branches/OMEdit/OMEditGUI/LibraryTreeWidget.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/LibraryTreeWidget.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/LibraryTreeWidget.cpp	(revision 13537)
@@ -572,5 +572,5 @@
 }
 
-Component_OMC* LibraryTreeWidget::getComponentObject(QString className)
+Component* LibraryTreeWidget::getComponentObject(QString className)
 {
   foreach (LibraryComponent *libraryComponent, mLibraryComponentsList)
@@ -839,5 +839,5 @@
   mClassName = className;
   //mpComponent = new Component(value, className, omc->isWhat(StringHandler::CONNECTOR, className), omc);
-  mpComponent = new Component_OMC(value, className, omc);
+  mpComponent = new Component(value, className, omc);
 
   if (mpComponent->boundingRect().width() > 1)
@@ -882,5 +882,5 @@
 }
 
-void LibraryComponent::hasIconAnnotation(Component_OMC *pComponent)
+void LibraryComponent::hasIconAnnotation(Component *pComponent)
 {
   if (!pComponent->getShapesList().isEmpty())
@@ -890,9 +890,9 @@
   else
   {
-    foreach (Component_OMC *inheritedComponent, pComponent->getInheritanceList())
+    foreach (Component *inheritedComponent, pComponent->getInheritanceList())
     {
       hasIconAnnotation(inheritedComponent);
     }
-    foreach (Component_OMC *childComponent, pComponent->getComponentsList())
+    foreach (Component *childComponent, pComponent->getComponentsList())
     {
       hasIconAnnotation(childComponent);
Index: /branches/OMEdit/OMEditGUI/LibraryTreeWidget.h
===================================================================
--- /branches/OMEdit/OMEditGUI/LibraryTreeWidget.h	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/LibraryTreeWidget.h	(revision 13537)
@@ -41,5 +41,5 @@
 
 class MainWindow;
-class Component_OMC;
+class Component;
 class OMCProxy;
 class LibraryTreeWidget;
@@ -130,5 +130,5 @@
   LibraryTreeNode* getLibraryTreeNode(QString nameStructure);
   void addLibraryComponentObject(LibraryComponent *libraryComponent);
-  Component_OMC *getComponentObject(QString className);
+  Component *getComponentObject(QString className);
   LibraryComponent* getLibraryComponentObject(QString className);
   bool isFileWritAble(QString filePath);
@@ -166,8 +166,8 @@
   ~LibraryComponent();
   QPixmap getComponentPixmap(QSize size);
-  void hasIconAnnotation(Component_OMC *pComponent);
+  void hasIconAnnotation(Component *pComponent);
 
   QString mClassName;
-  Component_OMC *mpComponent;
+  Component *mpComponent;
   QGraphicsView *mpGraphicsView;
   QRectF mRectangle;
